from coursA2Manosque import *

# Ouverture image + lecture
tab=pl.imread("lena.pgm")
pl.imshow(tab)
VisuImage(tab)

# Sous echantillonnage
sous_echantillonnage(tab,2) 
pl.figure()
sous_echantillonnage(tab,2,'True') 

# Quantification

visu_quantification(tab,2)
visu_quantification(tab,32) # Pour quelle valeur ne percoit on plus de differences ?


############################
#   Theoreme de Shannon    #
############################

# Sur un signal

nsamp=1000
fe=100
f=0.9
samples=range(nsamp)
samples=numpy.array(samples)
signal=numpy.array([cos(2*pi*f*x/fe) for x in samples]) # signal "continu"

fe2=2.5 # tester 3 pour voir la difference
samples2=numpy.array(range(fe2*nsamp/fe)) 
signal2=numpy.array([cos(2*pi*f*x/fe2) for x in samples2]) # signal sous-echantillonne

pl.plot(samples/float(fe),signal)
pl.plot(samples2/float(fe2),signal2)
pl.plot(samples2/float(fe2),signal2,'.',markersize=10)


#  Cas d'une image

a=1.0
b=-2.0
f=0.02
n=500
Im=numpy.zeros((n,n),dtype='float')
for x in range(Im.shape[0]):
    for y in range(Im.shape[1]):
        Im[x][y]=cos(2*pi*f*(a*x+b*y))

VisuImage(Im)
sous_echantillonnage(Im,10)
sous_echantillonnage(Im,25)

#########################################
#   Operations de base sur les images   #
#########################################

# Histogramme 

histograme2(tab,1)


# Changement de contraste

tab=pl.imread("lena.pgm")
tab=numpy.array(tab)
tab2=contraste(tab,100,150)
VisuImage(tab2) # aucune difference, la dynamique est recadree automatiquement
VisuImage2(tab2) # le changement de contraste se voit


# Masquage dans l'image

tab=pl.imread("axial.pgm")
VisuImage2(contraste(tab,0,5000)) # demasquage par un changement de contraste
VisuImage2(seuillage(tab,3)) # demasquage par un seuillage binaire

#########################
# Premiers filtres
#########################

tab=pl.imread("lena.pgm")
tab=numpy.array(tab,dtype=float) # important 
kmoy=(1.0/9.0)*numpy.array([[1.0,1.0,1.0],[1.0,1.0,1.0],[1.0,1.0,1.0]]) # filtre moyen de taille 3x3

tab_f1=filt.convolve(tab,kmoy) # filtrage rapide via scipy
VisuImage(tab_f1)
tab_f2=filtrage(tab,kmoy) # filtrage maison plus lent (quelques secondes si la taille des images ou des filtres sont importantes)
VisuImage(tab_f2) # Aucune difference visuellement 

Niter=100 # Application repetee du filtre moyen
u=copy.deepcopy(tab)
for t in range(Niter):
    u=copy.deepcopy(filt.convolve(u,kmoy)) 

VisuImage(u) # effet de flou

kdx=numpy.array([[0.0,0.0,0.0],[-1.0,1.0,0.0],[0.0,0.0,0.0]]) # filtre derivatif selon les x
kdy=numpy.array([[0.0,-1.0,0.0],[0.0,1.0,0.0],[0.0,0.0,0.0]]) # filtre derivatif selon les y

VisuImage(filt.convolve(tab,kdx))
VisuImage(filt.convolve(tab,kdy))

klap=numpy.array([[0.0,1.0,0.0],[1.0,-4.0,1.0],[0.0,1.0,0.0]]) # filtre laplacien
VisuImage(filt.convolve(tab,klap))

############################
#   Debruitage             #
############################


tab=pl.imread("lena.pgm")
tab=numpy.array(tab)

niveau_bruit=100 
bruit=niveau_bruit*numpy.random.random(numpy.prod(tab.shape)) # generation tableau de valeurs aleatoires entre 0 et niveau_bruit-1
bruit=bruit.reshape(tab.shape)
tab_bruit=tab+bruit # bruit uniforme
VisuImage(tab_bruit)

pourcent_bruit=10.0 # pourcentage de pixels affectes par le bruit
bruit_imp=numpy.random.random(tab.shape) # bruit impulsionnel ou poivre et sel
tab_bruit_imp=copy.deepcopy(tab) 
for i in range(tab.shape[0]):
    for j in range(tab.shape[1]):
        if bruit_imp[i,j]<pourcent_bruit/100.0:
            if numpy.random.random()<0.5:
                tab_bruit_imp[i,j]=0.0
            else:
                tab_bruit_imp[i,j]=255.0
            

tab_debruit=scipy.ndimage.gaussian_filter(tab_bruit,5.0) # filtre gaussien
VisuImage(tab_debruit)
tab_median=scipy.ndimage.median_filter(tab_bruit,5.0) # filtre median
VisuImage(tab_median)

tab_debruit2=scipy.ndimage.gaussian_filter(tab_bruit_imp,5.0)
VisuImage(tab_debruit2)
tab_median2=scipy.ndimage.median_filter(tab_bruit_imp,3.0)
VisuImage(tab_median2)

##########################
# Inpainting
##########################

masque=pl.imread("parrot-mask.pgm")
masque=masque/255
Im=pl.imread("parrot2.pgm")

dt=0.5 # pas de temps
n=1000 # iterations
lambd=0.2 # force du lissage
k = numpy.array([[0.0,1.0,0.0],[1.0,-4.0,1.0],[0.0,1.0,0.0]]) # filtre laplacien
u=copy.deepcopy(Im)
for i in range(n): # discretisation de type equation de la chaleur
    du=lambd*(1-masque)*filt.convolve(u,k)
    u=copy.deepcopy(u+dt*du)
    print i
    

    
############################
# Fourier                  #
############################

nsamp=1000
fe=500.0
f=20
samples=range(nsamp)
samples=numpy.array(samples)
signal=numpy.array([cos(2*pi*f*x/fe) for x in samples])

tf_signal=scipy.fftpack.fft(signal)
pl.plot(samples/fe,signal)
pl.xlabel("Temps (s)")
pl.ylabel("Signal")

pl.plot(samples*fe/nsamp,tf_signal)
pl.xlabel("Frequence (Hz)")
pl.ylabel("Spectre")
